#include <iostream>
#include <cmath>
#include <string>
#include <cstring>
#include <vector>
#include <fstream>
#include <algorithm>
#include <cstdio>
#include <cstdlib>
#define nextline { for (int c = getchar(); c != '\n' && c != EOF; c = getchar()); }
#define sqr(a) ((a)*(a))
#define has(mask,i) (((mask) & (1<<(i))) == 0 ? false : true)
#define TASK "bigmak"
using namespace std;

#define PII pair<int,int>
#define mp make_pair
#define pb push_back
typedef long long ll;
typedef long double ldb;

const int INF = (1 << 30) - 1;
const ldb EPS = 1e-9;

int n;
int a[100005];
void Load()
{
	scanf("%d", &n);
	for (int i = 0; i < n; i++)
		scanf("%d", &a[i]);
}

const int MAXN = 1000000;
int cnt[MAXN + 5];
inline void Solve1()
{
	for (int i = 0; i < n; i++)
		cnt[a[i]]++;
	vector <int> rb;
	for (int i = 0; i <= MAXN; i++)
	{
		for (int j = 0; j < cnt[i] / 2; j++)
			rb.pb(i);
		cnt[i] %= 2;
	}
	vector <int> re = rb;
	reverse(re.begin(), re.end());
	for (int i = 0; i <= MAXN; i++)
		if (cnt[i] > 0)
		{
			rb.pb(i);
			break;
		}
	for (int i = 0; i < (int)re.size(); i++)
		rb.pb(re[i]);	
	printf("%d\n", rb.size());
	for (int i = 0; i < (int)rb.size(); i++)
		printf("%s%d", (i > 0 ? " " : ""), rb[i]);
}

inline void Solve2()
{
	printf("%d\n", n);
	for (int i = 0; i < n; i++)
		printf("%d ", a[i]);
}

void Solve()
{
	int f = 0;
	for (int i = 0; !f && i < n; i++)
		f = f || (a[i] > MAXN);
	if (!f) Solve1();
	else Solve2();	
}

int main()
{
	freopen (TASK".in","r",stdin);
	freopen (TASK".out","w",stdout);
	Load();
	Solve();
	return 0;
}
