//#pragma comment(linker,"/STACK:256000000")

#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <queue>
#include <stack>
#include <bitset>
#include <algorithm>
#include <functional>
#include <numeric>
#include <utility>
#include <sstream>
#include <iostream>
#include <iomanip>
#include <cmath>
#include <ctime>
#include <cassert>
#include <stdio.h>
#include <string>
#include <memory.h>

using namespace std;

#define ldb long double
#define LL long long
#define nextline() {int c; while ((c = getchar()) != 10 && c != EOF);}

#define PI 3.1415926535897932384626433832795
#define EPS 1e-9

#define sqr(x) ((x) * (x))
#define ABS(a) ((a)<0?-(a):(a))
#define EQ(a,b) (ABS((a)-(b))<EPS)

#define all(a) a.begin(), a.end()
#define two(i) (1 << (i))
#define has(mask, i) ((((mask) & two(i)) == 0) ? false : true)

const int inf = 1000 * 1000 * 1000;
const LL inf64 = 1000LL * 1000LL * 1000LL * 1000LL * 1000LL * 1000LL;


#define MAXN 1000

long long a[20][20];
long long b[20][20];
int n, m;

void Load()
{
	cin >> n >> m;
	for (int i = 1; i <= n; i++)
		for (int j = 1; j <= m; j++)
			cin >> a[i][j];
}

void Solve()
{
	long long MX, MN;		
	for (int i = 1; i <= n; i++)
		for (int j = 1; j <= m; j++)
			b[i][j] = a[i][j];

	b[1][0] = b[0][1] = 1;

	for (int i = 1; i <= n; i++)
		for (int j = 1; j <= m; j++)
			b[i][j] *= max (b[i - 1][j], b[i][j - 1]);

	MX = b[n][m];

	for (int i = 0; i <= 10; i++)
		b[0][i] = b[i][0] = inf64;

	for (int i = 1; i <= n; i++)
		for (int j = 1; j <= m; j++)
			b[i][j] = a[i][j];

	b[1][0] = b[0][1] = 1;

	for (int i = 1; i <= n; i++)
		for (int j = 1; j <= m; j++)
			b[i][j] *= min (b[i - 1][j], b[i][j - 1]);

	 MN = b[n][m];


	 cout << MX - MN;
}
                
int main()
{
	//ios_base::sync_with_stdio(0);
	freopen("roads.in", "rt", stdin);
	freopen("roads.out", "wt", stdout);
	Load();
	Solve();
	return 0;
}
