#include <iostream>
#include <cmath>
#include <string>
#include <cstring>
#include <vector>
#include <fstream>
#include <algorithm>
#include <cstdio>
#include <cstdlib>
#define nextline { for (int c = getchar(); c != '\n' && c != EOF; c = getchar()) ; }
#define sqr(a) ((a)*(a))
#define has(mask,i) (((mask) & (1<<(i))) == 0 ? false : true)
#define TASK "roads"
using namespace std ;

#define PII pair<int,int>
#define mp make_pair
#define pb push_back
typedef long long ll ;
typedef long double ldb ;

const int INF = (1 << 30) - 1 ;
const ldb EPS = 1e-9 ;

int n, m;
int a[15][15];
void Load ()
{
	scanf("%d%d", &n, &m);
	for (int i = 0; i < n; i++)
		for (int j = 0; j < m; j++)
			scanf("%d", &a[i][j]);
}

ll ma;
ll mi;

void Rec1(int i, int j, ll cres)
{
	if (i == n - 1 && j == m - 1)
	{
		cres *= a[i][j];
		if (cres > ma) ma = cres;
		return;
	}
	if (i + 1 < n)
		Rec1(i + 1, j, cres * a[i][j]);
	if (j + 1 < m)
		Rec1(i, j + 1, cres * a[i][j]);		
}
 
void Rec2(int i, int j, ll cres)
{
	if (i == n - 1 && j == m - 1)
	{
		cres *= a[i][j];
		if (cres < mi) mi = cres;
		return;
	}
	if (cres > mi) return;
	if (i + 1 < n)
		Rec2(i + 1, j, cres * a[i][j]);
	if (j + 1 < m)
		Rec2(i, j + 1, cres * a[i][j]);	
}

void Solve ()
{
	ma = 0;
	mi = 1000000000000000000LL;
	Rec1(0, 0, 1);
	Rec2(0, 0, 1);
	cout << ma - mi;
}

int main()
{
	freopen (TASK".in","r",stdin) ;
	freopen (TASK".out","w",stdout) ;
	Load () ;
	Solve () ;
	return 0 ;
}
