#include <iostream>
#include <cmath>
#include <cstdio>
using namespace std;
#define ldb long double
const ldb pi = fabsl(atan2(0.0, -1.0));
const ldb eps = 1e-9;

int H1, M1, H2, M2;

void Load()
{
	
	char h1, h2, m1, m2;
	scanf("%c%c:%c%c", &h1, &h2, &m1, &m2);
	h1 -= '0';
	h2 -= '0';
	m1 -= '0';
	m2 -= '0';
	H1 = h1 * 10 + h2;
	M1 = m1 * 10 + m2;
	while ((h1 = getchar()) != 10);
	scanf("%c%c:%c%c", &h1, &h2, &m1, &m2);
	h1 -= '0';
	h2 -= '0';
	m1 -= '0';
	m2 -= '0';
	H2 = h1 * 10 + h2;
	M2 = m1 * 10 + m2;
}

void Solve()
{
	int res = 0;
//	M * 12 <= (H1 % 12) * 60 + M / 720;
// (H % 12) * 60 == M * 11
	int H;
	for (int i = H1 + 1; i <= H2 - 1; i++)
	{
		H = i % 12;
		if (H * 60 >= 0 && H * 60 <= 59 * 11)
			res++;
	}
	
	if (H1 == H2)
	{
		H = H1 % 12;
		if (H * 60 >= M1 * 11 && H * 60 <= M2 * 11) res++;
	}
	else
	{
		H = H1 % 12;
		if (H * 60 >= M1 * 11 && H * 60 <= 59 * 11) res++;
		H = H2 % 12;
		if (H * 60 >= 0 * 11 && H * 60 <= M2 * 11) res++;
	
	}
	cout << res;
}


int main()
{
	freopen("clock.in", "rt", stdin);
	freopen("clock.out", "wt", stdout);
	Load();
	Solve();
	return 0;
}